﻿using Microsoft.AspNetCore.Mvc;
using System.IO;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;
using Microsoft.AspNetCore.Hosting;
using System.Net.Http;
using System;
using Microsoft.AspNetCore.Http;
using System.Collections.Generic;

namespace DocIO_AspNetCore_WebApplication.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        private MemoryStream outputStream = null;
        public async System.Threading.Tasks.Task<ActionResult> Index(string button)
        {
            if (button == null)
                return View();

            // Gets file path for template Word document.
            string rootPath = _hostingEnvironment.WebRootPath;            

            FileStream fileStream = new FileStream(rootPath + "\\DocIO\\Template.docx", FileMode.Open);
            // Opens an existing document from file stream through constructor of WordDocument class
            WordDocument document = new WordDocument(fileStream, FormatType.Docx);
            fileStream.Dispose();            

            //Saves as DOCX and closes the WordDocument instance
            MemoryStream inputStream = new MemoryStream();
            document.Save(inputStream, FormatType.Docx);
            inputStream.Position = 0;
            document.Close();
            #region Service approach to send Word document as stream and gets resutlant converted PDF from it.
            HttpClient client = new HttpClient();
            // Gets Uri 
            string requestUri = "http://localhost:51241/api/WordToPDF/ConvertToPDF";
            // Posts input Word document to service and gets resultant PDF as content of HttpResponseMessage
            HttpResponseMessage response = null;
            try
            {
                response = await client.PostAsync(requestUri, new StreamContent(inputStream));
                //Dispose the input stream and client instances.
                inputStream.Dispose();
                client.Dispose();
            }
            catch (Exception ex)
            {
                // Gets exception here.
            }
            MemoryStream outputStream = null;
            // Gets PDF from content stream if service got success.
            if (response.IsSuccessStatusCode)
            {
                var responseHeaders = response.Headers;
                outputStream = new MemoryStream(await response.Content.ReadAsByteArrayAsync());
                outputStream.Position = 0;
                // Dispose the response instance.
                response.Dispose();
            }
            #endregion Service approach to send Word document as stream and gets resutlant converted PDF from it.

            return File(outputStream, "application/pdf", "Sample.pdf");
        }
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}